"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _a;
Object.defineProperty(exports, "__esModule", { value: true });
const zhin_1 = require("zhin");
const http_1 = require("http");
const koa_1 = __importDefault(require("koa"));
const koa_basic_auth_1 = __importDefault(require("koa-basic-auth"));
const koa_bodyparser_1 = __importDefault(require("koa-bodyparser"));
const router_1 = require("./router");
const process = __importStar(require("process"));
__exportStar(require("./router"), exports);
const koa = new koa_1.default();
koa.use((0, koa_basic_auth_1.default)({
    name: process.env.username + '',
    pass: process.env.password + '',
}));
const server = (0, http_1.createServer)(koa.callback());
const router = new router_1.Router(server, { prefix: process.env.routerPrefix || '' });
router.get('/api/plugins', (ctx) => {
    ctx.body = httpServer.app.pluginList.map(plugin => {
        return {
            name: plugin.name,
            status: plugin.status,
            filePath: plugin.filePath,
            middlewareCount: plugin.middlewares.length,
            commands: [...plugin.commands.values()].map(command => {
                return {
                    name: command.name,
                    desc: command.config.desc,
                    alias: command.aliasNames,
                    hidden: command.config.hidden,
                    help: command.help(),
                };
            }),
            services: [...plugin.services.entries()].map(([name]) => {
                return {
                    name,
                };
            }),
        };
    });
});
router.get('/api/config', (ctx) => {
    ctx.body = httpServer.app.config;
});
router.get('/api/adapter/:name/config', (ctx) => {
    ctx.body = (0, zhin_1.loadYamlConfigOrCreate)(`${ctx.params.name}.yaml`, '[]');
});
router.post('/api/adapter/:name/config', (ctx) => {
    (0, zhin_1.saveYamlConfig)(ctx.params.name, ctx.request.body);
});
router.get('/api/adapters', (ctx) => {
    ctx.body = [...httpServer.app.adapters.values()].map(adapter => {
        return {
            name: adapter.name,
            botsCount: adapter.bots.length,
        };
    });
});
router.get('/api/commands', (ctx) => {
    ctx.body = [...httpServer.app.commandList].map(command => {
        return {
            name: command.name,
            desc: command.config.desc,
            alias: command.aliasNames,
            hidden: command.config.hidden,
            help: command.help(),
        };
    });
});
const httpServer = new zhin_1.Plugin('http-server');
httpServer.service('server', server).service('koa', koa).service('router', router);
koa.use((0, koa_bodyparser_1.default)()).use(router.routes()).use(router.allowedMethods());
server.listen(Number(((_a = process.env).port || (_a.port = '8086'))), () => {
    const address = server.address();
    if (!address)
        return;
    httpServer.app?.logger.mark('server start at', address);
});
httpServer.on('plugin-beforeUnmount', () => {
    server.close();
});
exports.default = httpServer;
