/// <reference types="node" />
/// <reference types="koa__router" />
import { Layer, RouterOptions } from '@koa/router';
import * as http from 'http';
import { ServerOptions, WebSocketServer } from 'ws';
declare const KoaRouter: any;
type Path = string | RegExp;
export declare class Router extends KoaRouter {
    server: http.Server;
    wsStack: WebSocketServer[];
    whiteList: Path[];
    constructor(server: http.Server, options?: RouterOptions);
    register(...args: Parameters<(typeof KoaRouter)['register']>): any;
    destroy(layer: Layer): void;
    destroyWs(wsServer: WebSocketServer): void;
    ws(path: string, options?: Omit<ServerOptions, 'noServer' | 'path'>): import("ws").Server<typeof import("ws"), typeof http.IncomingMessage>;
}
export {};
