"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Router = void 0;
const zhin_1 = require("zhin");
const ws_1 = require("ws");
const url_1 = require("url");
const KoaRouter = require('@koa/router');
class Router extends KoaRouter {
    constructor(server, options) {
        super(options);
        this.server = server;
        this.wsStack = [];
        this.whiteList = []; //用于historyApi排除
    }
    register(...args) {
        const path = args[0];
        this.whiteList.push(path);
        return super.register(...args);
    }
    destroy(layer) {
        (0, zhin_1.remove)(this.stack, layer);
    }
    destroyWs(wsServer) {
        wsServer.close();
        (0, zhin_1.remove)(this.wsStack, wsServer);
    }
    ws(path, options = {}) {
        const wsServer = new ws_1.WebSocketServer({
            noServer: true,
            path,
            ...options,
        });
        this.wsStack.push(wsServer);
        this.server.on('upgrade', (request, socket, head) => {
            const { pathname } = (0, url_1.parse)(request.url);
            if (this.wsStack.findIndex(wss => wss.options.path === path) === -1) {
                socket.destroy();
            }
            else if (pathname === path) {
                wsServer.handleUpgrade(request, socket, head, ws => {
                    wsServer.emit('connection', ws, request);
                });
            }
        });
        return wsServer;
    }
}
exports.Router = Router;
