'use strict';
var __createBinding =
  (this && this.__createBinding) ||
  (Object.create
    ? function (o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        var desc = Object.getOwnPropertyDescriptor(m, k);
        if (!desc || ('get' in desc ? !m.__esModule : desc.writable || desc.configurable)) {
          desc = {
            enumerable: true,
            get: function () {
              return m[k];
            },
          };
        }
        Object.defineProperty(o, k2, desc);
      }
    : function (o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
      });
var __setModuleDefault =
  (this && this.__setModuleDefault) ||
  (Object.create
    ? function (o, v) {
        Object.defineProperty(o, 'default', { enumerable: true, value: v });
      }
    : function (o, v) {
        o['default'] = v;
      });
var __importStar =
  (this && this.__importStar) ||
  function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null)
      for (var k in mod)
        if (k !== 'default' && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
  };
Object.defineProperty(exports, '__esModule', { value: true });
exports.addEntry = void 0;
const path = __importStar(require('path'));
const path_1 = require('path');
const fs_1 = require('fs');
const entries = {};
function addEntry(entry) {
  const key = Math.random().toString(36);
  entries[key] = entry;
  viteServer?.restart(false);
  return () => {
    delete entries[key];
    viteServer?.restart(false);
  };
}
exports.addEntry = addEntry;
let viteServer = null;
exports.default = async router => {
  const { createServer } = require('vite');
  const { default: vue } = require('@vitejs/plugin-vue');
  const root = path.resolve(path.dirname(require.resolve('@zhinjs/client')), '../app');
  viteServer = await createServer({
    root,
    server: {
      middlewareMode: true,
      fs: {
        strict: false,
      },
    },
    base: '/vite/',
    resolve: {
      dedupe: ['vue', 'vue-router'],
      alias: {
        '@zhinjs/client': require.resolve('@zhinjs/client'),
      },
    },
    optimizeDeps: {
      include: ['vue', 'vue-router'],
    },
    plugins: [vue()],
    appType: 'custom',
  });
  router.get('(/.+)*', async (ctx, next) => {
    await next();
    if (ctx.body || ctx.response.body) return;
    const name = ctx.path.replace(/^\/+/, '');
    const sendFile = filename => {
      ctx.type = (0, path_1.extname)(filename);
      return (ctx.body = (0, fs_1.createReadStream)(filename));
    };
    if (name.startsWith('entries-')) {
      const key = name.slice(0, 8);
      if (entries[key]) return sendFile(entries[key]);
    }
    const filename = (0, path_1.resolve)(root, name);
    if (!filename.startsWith(root) && !filename.includes('node_modules')) {
      return (ctx.status = 403);
    }
    const stats = await fs_1.promises.stat(filename);
    if (stats && stats?.isFile()) return sendFile(filename);
    const ext = (0, path_1.extname)(filename);
    if (ext && ext !== '.html') return (ctx.status = 404);
    const template = await fs_1.promises.readFile((0, path_1.resolve)(root, 'index.html'), 'utf8');
    ctx.type = 'html';
    ctx.body = await viteServer?.transformIndexHtml('', template);
  });
  router.all(
    '/vite(/.+)*',
    async (ctx, next) =>
      new Promise(resolve => {
        viteServer?.middlewares(ctx.req, ctx.res, resolve);
      }),
  );
  return () => {
    viteServer?.close();
    viteServer = null;
  };
};
